'use strict';

// @importFmJsLib "Results.js"

function AntivirusCheck() {
	this.response = {
		info: "",
		result: "",
		data: {
		}
	};
}

AntivirusCheck.prototype.run = function(config) {
	this.response.result = results.FAILING;
	
	var apiCall = AVAPI.getAVVersion(config.avproduct, config.allowed_consecutive_fails);
	
	if(apiCall.result) {
		this.response.result = results.PASSING;
	}
	else {
		this.response.data.externalApiError = apiCall.externalApiError;
		if(apiCall.errorCode != "0") {
			this.response.data.errorCode = apiCall.errorCode;
		}
	}
	
	this.response.info = apiCall.checkInfo;
	this.response.data.VersionPattern = apiCall.version;

	return this.response; 
};

function getCheck() {
	return new AntivirusCheck();
}
/*CHECKSUM: 
1c68afe23ba2f9430b378eeb8b09b7c162c2c61a *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_antivirus.js
*/ 
