'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function AutomatedTaskCheck() {
	this.response = {
		info: "",
		result: "",
		data: {
		}
	};	
}

AutomatedTaskCheck.prototype.run = function(config) {
    var argumentString = this.processArguments(config.arguments.commands, config.arguments.options);
    var apiResponse = ScriptRunnerAPI.runScript(config.scriptname, argumentString, config.scriptlanguage, config.timeout, config.checkid);
	
    if(apiResponse.failed){
        this.response.result = results.FAILING;
        if(apiResponse.errorCode) {
          this.response.data.errorCode = errors[apiResponse.errorCode];  
        }
    } else {
        this.response.result = results.PASSING;
    }
	
	this.response.data.status = apiResponse.status ? apiResponse.status : "";
	this.response.data.returncode = apiResponse.returncode ? apiResponse.returncode : "";
	this.response.data.command = apiResponse.command ? apiResponse.command : "";
	this.response.data.output = apiResponse.output ? apiResponse.output : "";
    
    return this.response;
};

AutomatedTaskCheck.prototype.processArguments = function(commands, options) {
  var argumentString = "";
  
  for (var i = 0; i < commands.length; ++i) {
    argumentString = argumentString.concat(" ", commands[i]); 
  };
  
  var optionKey;
  for (optionKey in options) {
    argumentString = argumentString.concat(" -", optionKey);
    if(options[optionKey] !== true) { //second arg set to boolean true if no second arg
      argumentString = argumentString.concat(" ", options[optionKey]);
    } 
  };
  
  if(argumentString.length > 1) {
    argumentString = argumentString.substring(1); //lose first space
  }
  
  return argumentString;
}

function getCheck() {
	return new AutomatedTaskCheck();
}
/*CHECKSUM: 
e062b4aa4ab28bb273dee6d843c352c9dd646ed5 *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_automated_task.js
*/ 
