'use strict';

// @importFmJsLib "CheckUtils.js"
// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function FileSizeCheck() {
  	this.response = {
    		info: "",
    		result: "",
    		data: {
    		}
  	};	
    this.checkUtils = new CheckUtils();
}

FileSizeCheck.prototype.run = function(config) {
  
    this.response.result = results.FAILING;

    var threshold = this.checkUtils.getThresholdInBytes(config.threshold, parseInt(config.units));
    
    var apiCall = FileSizeCheckAPI.fileFolderSizeCheck(config.includes, config.excludes, 0, (1000*60));

    if(apiCall.TimedOut) {
    	this.response.data.errorCode = errors.ERROR_FILESIZE_TIMEOUT;
    } else if(apiCall.ErrorCount > 0 || apiCall.Size == -1) {
    	this.response.data.errorCode = errors.ERROR_FILESIZE_FILEERRORS;
    } else if(config.operator == "0" && apiCall.Size <= threshold) {
    	this.response.result = results.PASSING;
    } else if(config.operator == "1" && apiCall.Size >= threshold) {
    	this.response.result = results.PASSING;
    }

    this.response.data.SizeInBytes = apiCall.Size;
    this.response.data.FileCount = apiCall.FileCount;
    this.response.data.ErrorCount = apiCall.ErrorCount;
    this.response.data.ExecutionTime = apiCall.TimedOut ? -1 : apiCall.ExecutionTime;
               
    return this.response;
};

function getCheck() {
    return new FileSizeCheck();
}
/*CHECKSUM: 
011f2f05671b5a377694cf11c01926dd12ea657c *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_file_size.js
*/ 
