'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function PhysicalDiskCheck() {
	this.wmiNamespace = "\\\\.\\root\\cimv2";
	this.wmiQuery = "Select DeviceID, Status from Win32_DiskDrive";
  
	this.response = {
		info: "",
		result: "",
		data: {}
	};
}

PhysicalDiskCheck.prototype.run = function(config) {

	this.response.result = results.PASSING;
  
	var apiCall = WMI_API.ConnectServer(this.wmiNamespace);
	if( !apiCall) {
		return this.fail(errors.ERROR_WMI_CANNOT_CONNECT);
	}
	var queryResults = WMI_API.ExecQuery(this.wmiQuery);
	
	var elements = Object.keys(queryResults).length;
	if( elements == 0 ) {
		return this.fail(errors.ERROR_WMI_CANNOT_EXECUTE_QUERY);
	}
	
	var i = 0;
	
	while( i < elements ) {
		var diskInfo = {};
		diskInfo.Name = queryResults[i].DeviceID;
		diskInfo.Status = queryResults[i].Status;
		
		if( diskInfo.Status != "OK" ) {
			this.response.result = results.FAILING;
			if(!this.response.data.PhysicalDisks) {
				this.response.data.PhysicalDisks = [];
			}
			this.response.data.PhysicalDisks.push(diskInfo);
		}
		i++;
	}
	return this.response;
};

PhysicalDiskCheck.prototype.fail = function(errCode) {
		this.response.data.error = errCode;
		this.response.result = results.FAILING;
		return this.response;
};

function getCheck() {
	return new PhysicalDiskCheck();
}/*CHECKSUM: 
62c09721d4616808990dde5777e02e435b87a4cd *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_physical_disk.js
*/ 
