'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function PingCheck() {
	this.response = {
		info: "",
		result: "",
		data: {
		}
	};
}

PingCheck.prototype.run = function(config) {
	var apiCall = NetworkCheckAPI.ping(config.pinghost);
	this.response.result = results.PASSING;
	this.response.info = apiCall.info;

	if (!apiCall.result) {
		this.response.result = results.FAILING;
		
		var apiCodeToCheckCode = {
			'ERROR_EMPTY_HOSTNAME' : 'ERROR_PING_INVALID_ADDRESS',
			'ERROR_ERROR' : 'ERROR_PING_ERROR',
			'ERROR_INVALID_ADDRESS' : 'ERROR_PING_INVALID_ADDRESS',
			'ERROR_CONNECTION_REFUSED' : 'ERROR_PING_CONNECTION_REFUSED',
			'ERROR_UNREACHABLE' : 'ERROR_PING_UNREACHABLE',
			'ERROR_TIMEOUT' : 'ERROR_PING_TIMEOUT'
		};
		
		this.response.data.errorCode = errors[apiCodeToCheckCode[apiCall.info]];
	}

	return this.response; 
};

function getCheck() {
	return new PingCheck();
}
/*CHECKSUM: 
e5539db3d41c2272b5c298303da4fd9368502c96 *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_ping.js
*/ 
