'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function TcpCheck() {
	this.response = {
		result: "",
		data: {
		}
	};
}

TcpCheck.prototype.run = function(config) {
	var NOT_ACCEPTING_CONNECTIONS = 1;
	
	var apiCall = NetworkCheckAPI.tcpConnect(config.hostname, config.port);
	
	if (config.mode == NOT_ACCEPTING_CONNECTIONS) {
		this.response.result = apiCall.connectionAccepted ? results.PASSING : results.FAILING;
		
	} else {
		this.response.result = apiCall.connectionAccepted ? results.FAILING : results.PASSING;
	}
	
	if (!apiCall.connectionAccepted) {
		var apiCodeToCheckCode = {
			'ERROR_EMPTY_HOSTNAME' : 'ERROR_TCP_INVALID_ADDRESS',
			'ERROR_IN_USE' : 'ERROR_TCP_IN_USE',
			'ERROR_NETWORK_DOWN' : 'ERROR_TCP_NETWORK_DOWN',
			'ERROR_ERROR' : 'ERROR_TCP_ERROR',
			'ERROR_INVALID_ADDRESS' : 'ERROR_TCP_INVALID_ADDRESS',
			'ERROR_CONNECTION_REFUSED' : 'ERROR_TCP_CONNECTION_REFUSED',
			'ERROR_UNREACHABLE' : 'ERROR_TCP_UNREACHABLE',
			'ERROR_TIMEOUT' : 'ERROR_TCP_TIMEOUT'
		};
		
		this.response.data.errorCode = errors[apiCodeToCheckCode[apiCall.info]];
	}

	return this.response; 
};

function getCheck() {
	return new TcpCheck();
}
/*CHECKSUM: 
574e3a91d0b2b64fdc6cee5a004561a810c1e67f *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_tcp.js
*/ 
