'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function WebPageCheck() {
    this.response = {
        info: "",
        result: "",
        data: {}
    };
}

WebPageCheck.prototype.run = function(config) {
    var url = config.url;


    if (url.indexOf("http://") != 0 && url.indexOf("https://") != 0 && url.indexOf("ftp://") != 0 && url.indexOf("gopher://") != 0) {
        url = "http://" + url;
    }

    var apiCall = NetworkCheckAPI.loadWebPage(url);

    if (!apiCall.result) {
        this.response.result = results.FAILING;
        this.response.data.errorCode = errors.ERROR_WEBPAGE_PAGE_NOT_FOUND;
        return this.response;
    }

    if (apiCall.html.toLowerCase().indexOf(config.matchtext.toLowerCase()) == -1) {
        this.response.result = results.FAILING;
        this.response.data.errorCode = errors.ERROR_WEBPAGE_TEXT_NOT_FOUND;
        return this.response;
    }

    this.response.result = results.PASSING;
    return this.response;
};

function getCheck() {
    return new WebPageCheck();
}
/*CHECKSUM: 
c1fce016658fade0703d4d3f8bc72e03355f6420 *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_web_page.js
*/ 
