'use strict';

// @importFmJsLib "Results.js"
// @importFmJsLib "Errors.js"

function WSUSCheck() {
	this.response = {
		info: "",
		result: "",
		data: {
		}
	};	
}

WSUSCheck.prototype.run = function(config) {
	var apiCall = WSUSCheckAPI.checkWSUS(config.active, config.computersneedingupdatesthreshold, config.computerswithupdateerrorsthreshold, config.updatesneededthreshold, config.updateswitherrorsthreshold, config.computersoverduethreshold);
	
	this.response.result = apiCall.result ? results.PASSING : results.FAILING;

	if(apiCall.errorCode) {
		this.response.data.errorCode = errors[apiCall.errorCode];
	}

	if ('data' in apiCall) {
	    if ('WSUS' in apiCall.data) {
	        this.response.data = apiCall.data.WSUS;
	    }
	}
	
	return this.response; 
};

function getCheck() {
	return new WSUSCheck();
}
/*CHECKSUM: 
dce59dd1a9357fef819714de3ae85f0106613cea *C:\jenkins\workspace\FmPlugin_release_1.5.19\build\outputs\mainapp\RelWithDebInfo\Checks\check_wsus.js
*/ 
